unit hiImg_Text;

interface

{$I share.inc}

uses Windows,Kol,Share,Img_Draw;

type
  THIImg_Text = class(THIImg)
   private
   public
    procedure _work_doDraw(var _Data:TData; Index:word);
    procedure _var_TextWidth(var _Data:TData; Index:word);
    procedure _var_TextHeight(var _Data:TData; Index:word);
  end;

implementation

procedure THIImg_Text._work_doDraw;
begin
   _prop_DrawSource(_Data, tgText);
end;

procedure THIImg_Text._var_TextWidth;
var   bmp:PBitmap;
      dt:TData;
      Wnd:HWND;
      DC:HDC;
      SizeFont: TSize;
      s: string;
begin
TRY
   dt := ReadData(_Data,_data_Bitmap,nil);
   s := ReadString(_Data,_data_Text,_prop_Text);
   wnd := ToInteger(dt);
   bmp := ToBitmap(dt);
   if bmp <> nil then
      DC := bmp.Canvas.Handle 
   else
      DC := GetDC(wnd);
   if GetDeviceCaps(DC, TECHNOLOGY) <> DT_RASDISPLAY then exit; 
   hMyFont := GFont.Handle;
   SelectObject(DC, hMyFont);
   GetTextExtentPoint32(DC, PChar(s), Length(s), SizeFont);
   dtInteger(_Data, SizeFont.cx);
FINALLY
   if bmp = nil then ReleaseDC(Wnd,DC);
END;
end;

procedure THIImg_Text._var_TextHeight;
var   bmp:PBitmap;
      dt:TData;
      Wnd:HWND;
      DC:HDC;
      SizeFont: TSize;
      s: string;
begin
TRY
   dt := ReadData(_Data,_data_Bitmap,nil);
   s := ReadString(_Data,_data_Text,_prop_Text);
   wnd := ToInteger(dt);
   bmp := ToBitmap(dt);
   hMyFont := GFont.Handle;
   if bmp <> nil then
      DC := bmp.Canvas.Handle 
   else
      DC := GetDC(wnd);
   if GetDeviceCaps(DC, TECHNOLOGY) <> DT_RASDISPLAY then exit;
   SelectObject(DC, hMyFont);
   GetTextExtentPoint32(DC, PChar(s), Length(s), SizeFont);
   dtInteger(_Data, SizeFont.cy);
FINALLY
   if bmp = nil then ReleaseDC(Wnd,DC);
END;
end;

end.